/***************************************************************************
фиксация замеров давления с периодичностью tPress (100 мс)
>r2 - при старте анализ перемычки на входе pinIN
если = 1, то регистрация
если = 0, то вывод по UART
r4 - в EEPROM не пишется время

  This is a library for the BMP280 humidity, temperature & pressure sensor

  Designed specifically to work with the Adafruit BMEP280 Breakout 
  ----> http://www.adafruit.com/products/2651

  These sensors use I2C or SPI to communicate, 2 or 4 pins are required 
  to interface.

  Adafruit invests time and resources providing this open source code,
  please support Adafruit andopen-source hardware by purchasing products
  from Adafruit!

  Written by Limor Fried & Kevin Townsend for Adafruit Industries.  
  BSD license, all text above must be included in any redistribution
 ***************************************************************************/

//#include <Wire.h>
#include <SPI.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>
#include <EEPROM.h>


//#define BMP_SCK 13
//#define BMP_MISO 12
//#define BMP_MOSI 11 
#define BMP_CS 10
#define led 9    //контрольный светодиод (к GND)
#define pinIN 8  //перемычка на GND
#define prd433 5  //на модулятор передатчика

//Adafruit_BMP280 bme; // I2C
Adafruit_BMP280 bme(BMP_CS); // hardware SPI
//Adafruit_BMP280 bme(BMP_CS, BMP_MOSI, BMP_MISO,  BMP_SCK);

int addr = 0;
int itmp = 0;
#define tPress 100   //период опроса датчика
#define maxAddr 1024 //объем EEPROM



void setup() {
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);     
  pinMode(prd433, OUTPUT);     
  digitalWrite(prd433, LOW);   // выключить передатчик
  pinMode(pinIN, INPUT); 
  digitalWrite(pinIN, HIGH);   // включим резистор к VCC
  
  if (digitalRead(pinIN) == LOW) {
    //есть перемычка на землю - читаем EEPROM
     Serial.begin(9600);
     Serial.println("Read EEPROM from MC & BMP280");
     for (addr=0; addr<maxAddr; addr = addr +2) {
 //       byte tLow  = EEPROM.read(addr);
 //       byte tHigh = EEPROM.read(addr+1);
        byte aLow  = EEPROM.read(addr);
        byte aHigh = EEPROM.read(addr+1);
  
  Serial.print(addr);
  Serial.print(";  ");
//  Serial.print(tLow+tHigh*256);  //время в мс
//  Serial.print(";  ");
  Serial.print(aLow+aHigh*256);  //высота в десятых долях метра
  Serial.print(";  ");
  Serial.println();
      
     }
   
     Serial.println("The End Read EEPROM");
     while(1);
  }  
  
//  Serial.begin(9600);
//  Serial.println(F("BMP280 test"));
  
  if (!bme.begin()) {  
//    Serial.println(F("Could not find a valid BMP280 sensor, check wiring!"));
  while(1) { 
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(250);                // wait for a 1/4 second
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    delay(250);                // wait for a second
    //частые мигания если ошибка обнаружения BMP280
  }
//    while (1);
  }
  //пауза порядка минуты перед началом записи - двойные вспышки
  for (itmp = 0; itmp < 30; itmp++) {
     digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
	 analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
	 delay(200);
     digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
	 digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
	 delay(200);
     digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
	 analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
	 delay(200);
     digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
	 digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
	 delay(2000);
  }    
   
}

void loop() {
  long int tTek = millis();
  
  //контрольное мигание 1/8   2 сек
  int tTmp = highByte(tTek) & B00000111;
  if (tTmp == 0)  {   
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
	analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
  }
  else {
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
	digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
  }    
//    Serial.print(F("Temperature = "));
//    Serial.print(bme.readTemperature());
//    Serial.println(" *C");
 
//Давление    
//  long int valPress = bme.readPressure();  //давление в Паскалях (101000 Pa)
//    Serial.print(F("Pressure = "));
//    Serial.print(bme.readPressure());
//    Serial.println(" Pa");

//Высота
//    Serial.print(F("Approx altitude = "));
  unsigned int valAlt = bme.readAltitude(1013.25) * 10; //analogRead(0) / 4;
    
//    Serial.print(valAlt);  //bme.readAltitude(1013.25)); // this should be adjusted to your local forcase
//    Serial.println(" m");
    
//    Serial.println();
  
  // write the value to the appropriate byte of the EEPROM.
  // these values will remain there when the board is
  // turned off.
  
  //надо записать:
  //  два младших байта из tTek         2
  //  два байта из valAlt               2
  //(может быть и давление)
  //  четыре байта из valPress          4
//  EEPROM.write(addr, lowByte(tTek));
//  EEPROM.write(addr+1, highByte(tTek));
  EEPROM.write(addr, lowByte(valAlt));
  EEPROM.write(addr+1, highByte(valAlt));
  
  // advance to the next address.  there are 512 bytes in 
  // the EEPROM, so go back to 0 when we hit 512.
  addr = addr + 2;
  if (addr == maxAddr)  {
 //   addr = 0;  //циклическая перезапись (!?)
 //память заполнена - светодиод включаем непрерывно
     digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
     while (1) {  //непрерывно передаем "Ж" (...-)
		analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
		delay(200);
		digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
		delay(200);
		analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
		delay(200);
		digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
		delay(200);
		analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
		delay(200);
		digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
		delay(200);
		analogWrite(prd433,127);   //вкл.модуляция перед. 1000Гц
		delay(600);
		digitalWrite(prd433,LOW);   //выкл.модуляция перед. 
		delay(800);
	 } ;
  }
    
  while ((tTek + tPress) > millis()) {} 
//    delay(100);
}
